/***************************************************************************
                          ksensorscfg.cpp  -  description
                             -------------------
    begin                : mi� may 8 2002
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qvariant.h>
#include <qframe.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qimage.h>
#include <qpixmap.h>
#include <qapplication.h>

#include <klocalizedstring.h>
#include <kaboutdata.h>
#include <kpagedialog.h>

#include "general.h"
#include "sensordevsgroups.h"
#include "sensorslist.h"
#include "generalcfg.h"
#include "lmsensorscfg.h"
#include "aboutcfgdesign.h"
#include "ksensorscfg.h"


KSensorsCfg::KSensorsCfg( ksensorsMain *kmMainIn, const QString &name)
: KPageDialog(/* IconList, name, Apply|Close, Close */)
{
   Q_UNUSED(name);

    sensorDevsGroups *sensorDGList;

    kmMain = kmMainIn;

   //resize( 558, 370 );
//   setSizePolicy(QSizePolicy(QSizePolicy::Minimum, QSizePolicy::Minimum));

    const KAboutData kadAboutData = KAboutData::applicationData();

//   setWindowTitle( i18n( kadAboutData.displayName().toLatin1() + " Configuration") );
    setWindowTitle( i18n( "Configuration") );
    setModal( true );
    setFaceType( List );
    setStandardButtons( QDialogButtonBox::Apply | QDialogButtonBox::Close );

    QFrame *page = new QFrame();
    QVBoxLayout *lay;

    KPageWidgetItem *kpwiPage = addPage ( page, i18n("Global settings") );
    kpwiPage->setHeader ( i18n("Global settings") );
    kpwiPage->setIcon( QIcon ( findIcon("earth.png") ) );

    m_generalcfg = new GeneralCfg( kmMain, page );
    lay = new QVBoxLayout( page );
    lay->addWidget(m_generalcfg);

    connect( button(QDialogButtonBox::Apply), SIGNAL(clicked(bool)), m_generalcfg, SLOT(slotApplyChanges()));


//   const QObjectList *list= sensors->getSensorsChips();
//   if(list) 
   {
    sensorDGList = kmMain->getSensorDGList();

    for ( multiMapSensorsList::iterator it = sensorDGList->sensorsList.begin(); it != sensorDGList->sensorsList.end(); ++it )
    {
        SensorsList *chip = *it;

        if ( chip )
            cfgWidget = new LMSensorsCfg( this, kmMain, chip );
        else
            std::abort();
    }

   }

   adjustSize();
}

KSensorsCfg::~KSensorsCfg()
{
}
