/***************************************************************************
                          display.h  -  description
                             -------------------
    begin                : Sun Nov 11 2001
    Copyright	Giuseppe Della Bianca<giusdbg@gmail.com>

    original author	 : Miguel Novas
    email                : michaell@teleline.es
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef PANEL_H
#define PANEL_H

#include <qframe.h>
#include <qpalette.h>

#include "ksensorssetting.h"

/**
  *@original author Miguel Novas
  */

class Panel : public QFrame, public ksensorsSetting
{
Q_OBJECT
public:

	Panel(QWidget *parent, const QString &name);
	~Panel();

  inline const QColor &getColorTitle() { return palette().color ( QPalette::Text ); };
  inline const QColor &getColorValue() { return palette().color ( QPalette::WindowText ); };

  void updateFrame();

public Q_SLOTS:

 virtual void updateInfo(){};

Q_SIGNALS:

  void eventReceived(QEvent *);

private:

  bool eventFilter( QObject *o , QEvent *e) override;

protected:

  void paintEvent( QPaintEvent *e ) override;

private:

  bool panelSolid;
  double panelOpacityValue;
};

#endif
